<?php

// +---------------------------------------------------------------------------+
// | Stats Geeklog Plugin 1.1                                                  |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author: Tom Willett       - tomw@pigstye.net                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');


// Only let admin users access this page
if ((!SEC_inGroup('Root')) && (!SEC_hasRights('stats.view'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Main 
*/


if ($action == 'on') {
    DB_query("UPDATE {$_TABLES['st_vars']} SET value='1' where name='capture'");
    $_ST_VARS['capture'] = '1';
} else if ($action == 'off') {
    DB_query("UPDATE {$_TABLES['st_vars']} SET value='0' where name='capture'");
    $_ST_VARS['capture'] = '0';
}
if ($newipaction == $LANG_ST00['addip']) {
    DB_query("INSERT INTO {$_TABLES['ignore_ip']} VALUES ('$newip')",1);
    array_push($_ST_IP_IGNORE,$newip);
} else if ($newipaction == $LANG_ST00['deleteip']) {
    DB_query("DELETE FROM {$_TABLES['ignore_ip']} WHERE ip='$newip'",1);
    $asize=sizeof($_ST_IP_IGNORE);
    for($i=0;$i<$asize;$i++) {
        $j=array_shift($_ST_IP_IGNORE);
        if ($j != $newip) { array_push($_ST_IP_IGNORE,$j); }
    }
}

if ($newuseraction == $LANG_ST00['adduser']) {
    DB_query("INSERT INTO {$_TABLES['ignore_user']} VALUES ('$newuser')",1);
    array_push($_ST_USER_IGNORE,$newuser);
} else if ($newuseraction == $LANG_ST00['deleteuser']) {
    DB_query("DELETE FROM {$_TABLES['ignore_user']} WHERE username='$newuser'",1);
    $asize=sizeof($_ST_USER_IGNORE);
    for($i=0;$i<$asize;$i++) {
        $j=array_shift($_ST_USER_IGNORE);
        if ($j != $newuser) { array_push($_ST_USER_IGNORE,$j); }
    }
}

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
$T->set_file('admin', 'admin.thtml');
$T->set_block('admin','IP','ABlock');
$T->set_block('admin','USER','BBlock');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('header', $LANG_ST00['admin']);
$T->set_var('site_admin_url', $_CONF['site_admin_url']);
if ($_ST_VARS['capture'] == '1') {
    $T->set_var('adminmsg1', $LANG_ST00['captureon']);
    $T->set_var('btnmsg', $LANG_ST00['turnoff']);
    $T->set_var('action','off');
} else {
    $T->set_var('adminmsg1', $LANG_ST00['captureoff']);
    $T->set_var('btnmsg', $LANG_ST00['turnon']);
    $T->set_var('action','on');
}
$T->set_var('ignoreip_msg',$LANG_ST00['ipignored']);
$T->set_var('ipbtnmsg',$LANG_ST00['addip']);
$T->set_var('dipbtnmsg',$LANG_ST00['deleteip']);
$i=1;
foreach ($_ST_IP_IGNORE as $ip) {
    $T->set_var("ip{$i}",$ip);
    $i++;
    if ($i == 5) {
        $i=1;
        $T->Parse('ABlock','IP',true);
        $T->set_var('ip2','');
        $T->set_var('ip3','');
        $T->set_var('ip4','');
    }
}
if ($i != 1) {
    $T->Parse('ABlock','IP',true);
}
$T->set_var('ignoreuser_msg',$LANG_ST00['userignored']);
$T->set_var('userbtnmsg',$LANG_ST00['adduser']);
$T->set_var('duserbtnmsg',$LANG_ST00['deleteuser']);
$i=1;
foreach ($_ST_USER_IGNORE as $user) {
    $T->set_var("user{$i}",$user);
    $i++;
    if ($i == 5) {
        $i=1;
        $T->Parse('BBlock','USER',true);
        $T->set_var('user2','');
        $T->set_var('user3','');
        $T->set_var('user4','');
    }
}
if ($i != 1) {
    $T->Parse('BBlock','USER',true);
}

$T->parse('output','admin');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;
?>
