<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | upgrade.php                                                               |
// |                                                                           |
// | This file upgrades the Stats plugin for Geeklog.                          |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats upgrade page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/* 
* Upgrade from 1.0 to 1.1
* 
*/
function plugin_upgrade_stats() 
{
    global $_TABLES;
    
    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='1.1' WHERE pi_name = 'stats'",1);    
    COM_errorLog("Stats Plugin upgraded to 1.1",1);
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$display .= COM_startBlock($LANG_ST00['upgrade_head']);

if ($action == 'upgrade') {
    plugin_upgrade_stats();
} else if ($action == 'install') {
    print COM_refresh($_CONF[site_admin_url] . '/plugins/stats/install.php');
    exit;
}

$result = DB_query("SELECT * FROM " . $_TABLES['plugins'] . " WHERE pi_name = 'stats'");
$nrows = DB_numRows($result);

if ($nrows == 0) {
	$T = new template($_CONF['path'] . 'plugins/stats/templates');
	$T->set_file('install', 'upgrade.thtml');
	$T->set_var('site_url',$_CONF['site_url']);
	$T->set_var('site_admin_url',$_CONF['site_admin_url']);
	$T->set_var('install_header',$LANG_ST00['notinstalled']);
	$T->set_var('installmsg1',$LANG_ST00['notinstalled_msg2']);
	$T->set_var('installmsg2',"");
	$T->set_var('btnmsg',$LANG_ST00['install']);
	$T->set_var('action','install');
	$T->parse('output','install');
    $display .= $T->finish($T->get_var('output'));
} else {
    $A = DB_fetchArray($result);
    if ($A['pi_version'] == '1.1') {
    	$T = new template($_CONF['path'] . 'plugins/stats/templates');
	    $T->set_file('install', 'upgrade.thtml');
    	$T->set_var('site_url',$_CONF['site_url']);
	    $T->set_var('site_admin_url',$_CONF['site_admin_url']);
    	$T->set_var('install_header',$LANG_ST00['installed']);
	    $T->set_var('installmsg1',$LANG_ST00['upgrade_msg']);
    	$T->set_var('installmsg2',$LANG_ST00['up_complete']);
	    $T->set_var('btnmsg',$LANG_ST00['upgrade']);
    	$T->set_var('action','nothing');
	    $T->parse('output','install');
        $display .= $T->finish($T->get_var('output'));
    } else {
    	$T = new template($_CONF['path'] . 'plugins/stats/templates');
	    $T->set_file('install', 'upgrade.thtml');
    	$T->set_var('site_url',$_CONF['site_url']);
	    $T->set_var('site_admin_url',$_CONF['site_admin_url']);
    	$T->set_var('install_header',$LANG_ST00['installed']);
	    $T->set_var('installmsg1',$LANG_ST00['upgrade_msg']);
    	$T->set_var('installmsg2',$LANG_ST00['upgrade_msg2']);
	    $T->set_var('btnmsg',$LANG_ST00['upgrade']);
    	$T->set_var('action','upgrade');
	    $T->parse('output','install');
        $display .= $T->finish($T->get_var('output'));
    }
}

$display .= COM_endBlock();
$display .= COM_siteFooter(true);

echo $display;

?>