<?php
//
// +---------------------------------------------------------------------------+
// | Stats Plugin 1.0 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the stats      |
// | PHP files.                                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett       - tomw*pigstye.net                             |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

$langfile = $_CONF['path'] . 'plugins/stats/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/stats/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/stats/config.php');

///////////////////////////////////////////////////////////////////
///  Set up config variables and call to add stats to database  //
/////////////////////////////////////////////////////////////////

$_ST_IP_IGNORE=array();
$_ST_USER_IGNORE=array();
$_ST_VARS=array();

setup_stats();

function setup_stats() {
    global $_TABLES, $_ST_IP_IGNORE, $_ST_USER_IGNORE, $_ST_VARS;

    $rec = DB_query("SELECT * FROM {$_TABLES['st_vars']}",1);
    $nrows = DB_numRows($rec);
    for($i=0;$i<$nrows;$i++) {
        $A=DB_fetchArray($rec);
        $varname=$A['name'];
        $_ST_VARS["$varname"]=$A['value'];
    }


    if ($_ST_VARS['capture'] == '1') {
        $rec = DB_query("SELECT * FROM {$_TABLES['ignore_ip']}",1);
        $nrows = DB_numRows($rec);
        for($i=0;$i<$nrows;$i++) {
            $A=DB_fetchArray($rec);
            $_ST_IP_IGNORE[$i]=$A['ip'];
        }
        $rec = DB_query("SELECT * FROM {$_TABLES['ignore_user']}",1);
        $nrows = DB_numRows($rec);
        for($i=0;$i<$nrows;$i++) {
            $A=DB_fetchArray($rec);
            $_ST_USER_IGNORE[$i]=$A['username'];
        }
        ST_addStats();
    }
}

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
*/
function plugin_getmenuitems_stats()
{
    global $_CONF, $LANG_ST00, $_ST_anon, $_ST_anon_menu, $_ST_priv;
    
    $menuitems = array();
    if (($_ST_anon == 1) && ($_ST_anon_menu == 1)) {
        $tmp=$LANG_ST00['vis_stats'];
        $menuitems["$tmp"] = $_CONF['site_url'] . '/stats/index.php';
    }
    if ($_ST_priv == 1) {
        $tmp = $LANG_ST00['priv_pol'];
        $menuitems["$tmp"] = $_CONF['site_url'] . '/stats/privpol.php';
    }
    return $menuitems;
}

/**
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
*/
function plugin_commentsupport_stats() 
{
    return false;
}

/**
* Shows the statistics for the stats plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the stats
*
* @showsitestate        int         Flag to let us know which stats to get
*/
function plugin_showstats_stats($showsitestats) 
{
	global $_TABLES, $LANG_ST00, $_ST_stats;
	
    if (($showsitestats == 1) && ($_ST_stats == 1)) {
        $rec=DB_query("SELECT DISTINCT ip from {$_TABLES['userstats']}");
        $visitors=DB_numRows($rec);
        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>" . $LANG_ST00['unique_visitors'] . "</td>";
        $retval .= "<td align='right'>" . $visitors . "&nbsp;&nbsp </td></tr></table>";
        $total_stats=DB_count($_TABLES['users']);
        $retval .= "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>" . $LANG_ST00['users'] . "</td>";
        $retval .= "<td align='right'>" . $total_stats . "&nbsp;&nbsp </td></tr></table>";
    	                                
    } else {
	    $retval = '';
	}
	return $retval;
}

/**
* This will put an option for stats in the command and control block on
* moderation.php
*
*/
function plugin_cclabel_stats() 
{
    global $LANG_ST00, $_CONF;

    return array($LANG_ST00['vis_stats'],$_CONF['site_admin_url'] . '/plugins/stats/index.php',$_CONF['site_url'] . '/stats/images/stats.gif');
}

/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_stats() 
{
    global $LANG_ST00, $_CONF;

    if (SEC_hasRights('stats.admin')) {
        return array($LANG_ST00['vis_stats'],$_CONF['site_admin_url'] . '/plugins/stats/index.php',0);
    }
}

/**
* returns the user option for this plugin
*
*/
function plugin_getuseroption_stats() 
{
    global $LANG_ST00, $_CONF, $_ST_user;

    if ((SEC_hasRights('stats.view')) && ($_ST_user == 1)) {
        return array($LANG_ST00['vis_stats'],$_CONF['site_url'] . '/stats/index.php',0);
    }
}

//////////////////////////////////////////////////////////////////////////////////
//  STATS Functions                                                             //
//////////////////////////////////////////////////////////////////////////////////

/*
* Return an array with Browser type and Version
*/
function ST_getBrowser()
{
    global $HTTP_USER_AGENT;
    
    $browser=array();
    if(@eregi("(opera) ([0-9]{1,2}.[0-9]{1,3}){0,1}",$HTTP_USER_AGENT,$match) || @eregi("(opera/)([0-9]{1,2}.[0- 9]{1,3}){0,1}",$HTTP_USER_AGENT,$match))
    {
        $browser['type']= "Opera"; 
        $browser['ver']=$match[2];
    } elseif(eregi("(konqueror)/([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) {
        $browser['type'] = "Konqueror"; 
        $browser['ver']=$match[2];
    } elseif(eregi("(lynx)/([0-9]{1,2}.[0-9]{1,2}.[0-9]{1,2})",$HTTP_USER_AGENT,$match)) {
        $browser['type'] = "Lynx"; 
        $browser['ver']=$match[2];
    } elseif(eregi("(links) \(([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) {
        $browser['type'] = "Links"; 
        $browser['ver']=$match[2];
    } elseif(eregi("(msie) ([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) {
        $browser['type'] = "MSIE"; 
        $browser['ver']=$match[2];
    } elseif(eregi("(netscape6)/(6.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) {
        $browser['type'] = "Netscape"; 
        $browser['ver']=$match[2];
    } elseif(eregi("mozilla/5",$HTTP_USER_AGENT)) {
        $browser['type'] = "Mozilla"; 
        $browser['ver']="Unknown";
    } elseif(eregi("(mozilla)/([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) {
        $browser['type'] = "Netscape "; 
        $browser['ver']=$match[2];
    } elseif(eregi("w3m",$HTTP_USER_AGENT)) {
        $browser['type'] = "w3m"; 
        $browser['ver']="Unknown";
    } else {
        $browser['type'] = "Unknown"; 
        $browser['ver']="Unknown";
    }
    return $browser;
}

/*
* Return Computer Type
*/
function ST_getComputerType() 
{
    global $HTTP_USER_AGENT;
    
	if(eregi("linux",$HTTP_USER_AGENT))
	{
    	$return = "Linux";
	} elseif(eregi("win32",$HTTP_USER_AGENT)) {
    	$return = "Windows";
	} elseif((eregi("(win)([0-9]{2})",$HTTP_USER_AGENT,$match)) || (eregi("(windows) ([0-9]{2})",$HTTP_USER_AGENT,$match))) {
    	$return = "Windows $match[2]";
	} elseif(eregi("(winnt)([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) {
	    $return = "Windows NT $match[2]";
	} elseif(eregi("(windows nt)( ){0,1}([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) {
    	$return = "Windows NT $match[3]";
	} elseif(eregi("mac",$HTTP_USER_AGENT)) {
    	$return = "Macintosh";
	} elseif(eregi("(sunos) ([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) {
    	$return = "SunOS $match[2]";
 	} elseif(eregi("(beos) r([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) {
    	$return = "BeOS $match[2]";
    } elseif(eregi("freebsd",$HTTP_USER_AGENT)) {
        $return = "FreeBSD";
    } elseif(eregi("openbsd",$HTTP_USER_AGENT)) {
        $return = "OpenBSD";
    } elseif(eregi("irix",$HTTP_USER_AGENT)) {
        $return = "IRIX";
    } elseif(eregi("os/2",$HTTP_USER_AGENT)) {
        $return = "OS/2";
    } elseif(eregi("plan9",$HTTP_USER_AGENT)) {
        $return = "Plan9";
    } elseif(eregi("unix",$HTTP_USER_AGENT) || eregi("hp-ux",$HTTP_USER_AGENT)) {
        $return = "Unix";
    } elseif(eregi("osf",$HTTP_USER_AGENT)) {
        $return = "OSF";
    } else {
        $return = "Unknown";
    }       
    return $return;
}

/*
* add stats to database
*/
function ST_addStats()
{
    global $HTTP_USER_AGENT, $REQUEST_METHOD, $REMOTE_ADDR, $QUERY_STRING, $SCRIPT_NAME, $_USER, $_ST_USER_IGNORE, $_ST_IP_IGNORE, $HTTP_REFERER, $_TABLES;
    
    $browser = ST_getBrowser();
    if ($_USER['uid'] < 2) {
        $usr = 1; 
        $usern = 'Anonymous';
    } else {
        $usr = $_USER['uid'];
        $usern = $_USER['username'];
    }
    if ((in_array($_USER['username'],$_ST_USER_IGNORE)) || (in_array($REMOTE_ADDR,$_ST_IP_IGNORE))) {
    } else {
        $sql = "INSERT INTO " . $_TABLES['userstats'] . " Set uid='" . $usr
            . "', username='" . $usern
            . "', user_agent='" . $HTTP_USER_AGENT
            . "', ip='" . $REMOTE_ADDR
            . "', host='" . gethostbyaddr($REMOTE_ADDR)
            . "', browser='" . $browser['type']
            . "', version='" . $browser['ver']
            . "', platform='" . ST_getComputerType()
            . "', date='" . date("Y") . date("m") . date("d")
            . "', dayofweek='" . date("l")
            . "', month='" . date("M")
            . "', monthn='" . date("m")
            . "', day='" . date("d")
            . "', year='" . date("Y")
            . "', hour='" . date("H")
            . "', minute='" . date("i")
            . "', referer='" . $HTTP_REFERER
            . "', query_string='" . $QUERY_STRING
            . "', request='" . $REQUEST_METHOD
            . "', page='" . substr($SCRIPT_NAME,1) . "'";
       DB_query($sql);
   }
}

/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undue anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
* @steps   Array    Holds all the steps that have been completed by the install
*
*/  
function plugin_uninstall_stats($steps = '')
{
    global $_TABLES;

    $pi_name='stats';
    $FEATURES = array ( 'stats.admin', 'stats.view');
    $TABLES = array ('userstats','ignore_ip','ignore_user','st_vars');
    
    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the Stats plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'stats'",1);

    // Drop stats tables
    foreach($TABLES as $table) {
        $t = $_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_group_id'");
    
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_group_id'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
        
    COM_errorLog('...success',1);
}

/*
* Stats block to show whos online now, # visitors today, registered today, new today, referers today
*
* @return   string  formatted html for block
*/
function phpblock_statsstats() {
    global $_USER, $_CONF, $_TABLES, $LANG01, $LANG_ST00;
    
    // Code borrowed from lib-common.php
    
    if( empty( $_USER['uid'] ) OR $_USER['uid'] == 1 )
    {
        // The following code handles anonymous users so they show up properly
        DB_query( "DELETE FROM {$_TABLES['sessions']} WHERE remote_ip = '$REMOTE_ADDR' AND uid = 1" );
        // Build a useless sess_id (needed for insert to work properly)
        mt_srand(( double )microtime() * 1000000 );
        $sess_id = mt_rand();
        $curtime = time();
        // Insert anonymous user session
        DB_query( "INSERT INTO {$_TABLES['sessions']} (sess_id, start_time, remote_ip, uid) VALUES ($sess_id,$curtime,'$REMOTE_ADDR',1)" );
    }
    // Clear out any expired sessions
    DB_query( "DELETE FROM {$_TABLES['sessions']} WHERE uid = 1 AND start_time < " . ( time() - $_CONF['whosonline_threshold'] ));

    // Code borrowed from whose online block
    $expire_time = time() - $_CONF['whosonline_threshold'];
    $result = DB_query( "SELECT DISTINCT {$_TABLES['sessions']}.uid, username,photo FROM {$_TABLES['sessions']},{$_TABLES['users']} WHERE {$_TABLES['users']}.uid = {$_TABLES['sessions']}.uid AND start_time >= $expire_time AND {$_TABLES['sessions']}.uid <> 1 ORDER BY username" );
    $nrows = DB_numRows( $result );
    $retval = "<table width='90%'><tr><td width='20%'><hr></td><td nowrap>";
    $retval .= $LANG_ST00['online'];
    $retval .= "</td><td width='60%'><hr></td></tr></table>";
    for( $i = 1; $i <= $nrows; $i++ )
    {
        $A = DB_fetchArray( $result );
        $retval .= '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '">' . $A['username'] . '</a>';
        if( !empty( $A['photo'] ) AND $_CONF['allow_user_photo'] == 1) 
        {
            $retval .= '&nbsp;<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '"><img src="' . $_CONF['layout_url'] . '/images/smallcamera.gif" border="0" alt=""></a>';
        }
        $retval .= '<br>';
    }
    $num_anon = DB_query( "SELECT DISTINCT uid,remote_ip FROM {$_TABLES['sessions']} WHERE uid = 1" );
    $num_anon = DB_numRows( $num_anon );
    if( $num_anon > 0 )
    {
        $retval .= $LANG01[41] . ': ' . $num_anon . '<br>';
    }
    $retval .= "<table width='90%'><tr><td width='20%'><hr></td><td nowrap>";
    $retval .= $LANG_ST00['stats'];
    $retval .= "</td><td width='60%'><hr></td></tr></table>";
    $pages = DB_count($_TABLES['userstats'],'date',date("Y") . date("m") . date("d"));
    $retval .= $pages . ' ' . $LANG_ST00['page_title'] . '<br>';
    $result = DB_query("SELECT DISTINCT IP from {$_TABLES['userstats']} where date = '" . date("Y") . date("m") . date("d") . "'");
    $nrows = DB_numRows($result);
    $retval .= $nrows . ' ' . $LANG_ST00['unique_visitors'] . '<br>';
    $retval .= "<table width='90%'><tr><td width='20%'><hr></td><td nowrap>";
    $retval .= $LANG_ST00['reg_users'];
    $retval .= "</td><td width='60%'><hr></td></tr></table>";
    $result = DB_query("SELECT DISTINCT uid from {$_TABLES['userstats']} where uid > 1 AND date = '" . date("Y") . date("m") . date("d") . "'");
    $nrows = DB_numRows($result);
    for ($i=0; $i < $nrows; $i++) {
        $B = DB_fetchArray($result);
        $rec = DB_query("SELECT uid, username, photo FROM {$_TABLES['users']} where uid = '" . $B['uid'] . "'");
        $A = DB_fetchArray( $rec );
        $retval .= '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '">' . $A['username'] . '</a>';
        if( !empty( $A['photo'] ) AND $_CONF['allow_user_photo'] == 1) 
        {
            $retval .= '&nbsp;<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '"><img src="' . $_CONF['layout_url'] . '/images/smallcamera.gif" border="0" alt=""></a>';
        }
        $retval .= '<br>';
    }
    $retval .= "<table width='90%'><tr><td width='20%'><hr></td><td nowrap>";
    $retval .= $LANG_ST00['new_users'];
    $retval .= "</td><td width='60%'><hr></td></tr></table>";
    $result = DB_query("select uid, username, photo from {$_TABLES['users']} where regdate >= date_sub(curdate(),INTERVAL 1 DAY)");
    $nrows = DB_numRows($result);
    for ($i=0; $i < $nrows; $i++) {
        $A = DB_fetchArray( $result );
        $retval .= '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '">' . $A['username'] . '</a>';
        if( !empty( $A['photo'] ) AND $_CONF['allow_user_photo'] == 1) 
        {
            $retval .= '&nbsp;<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '"><img src="' . $_CONF['layout_url'] . '/images/smallcamera.gif" border="0" alt=""></a>';
        }
        $retval .= '<br>';
    }
    $retval .= "<table width='90%'><tr><td width='20%'><hr></td><td nowrap>";
    $retval .= $LANG_ST00['referers'];
    $retval .= "</td><td width='60%'><hr></td></tr></table>";
    $result = DB_query("SELECT referer from {$_TABLES['userstats']} where date = '" . date("Y") . date("m") . date("d") . "'");
    $nrows = DB_numRows($result);
    for ($i=0; $i<$nrows; $i++) {
        $A=DB_fetchArray($result);
        $url = parse_url($A['referer']);
        $host = $url['host'];
        if (substr($host,0,4) == 'www.') {
            $host = substr($host,4);
        }
        if ($host == 'geeklog.sourceforge.net') {
            $host = 'geeklog.sf.net';
        }
        if ($host <> '' && $host <> 'pigstye.net') {
            $ref["$host"] += 1;
            $refurl["$host"] = $A['referer'];
        }
    }
    arsort($ref);
    foreach ($ref as $key => $value) {
        $retval .= '<a href="' . $refurl["$key"] . '">' . $key . '</a> - ' . $value . '<br>';
    }
    return $retval;
}
?>