<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | daily.php                                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let Root users access this page and anon if $_ST_anon = 1
if ((!SEC_inGroup('Root')) && ($_ST_anon != 1) && (!SEC_hasRights('stats.view'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

function DaysInMonth($month,$year) {
    if($month=='Feb') {
        if($year%4) { 
            $days = 28;
        } elseif($year%100) {
            $days = 29;
        } elseif($year%1000) {
            $days = 28;
        } else {
            $days = 29;
        }
    } elseif(($month=='Apr')||($month=='Jun') ||($month=='Sep')||($month=='Nov')) {
        $days = 30;
    } else {
        $days = 31;
    }
    return $days;
}

 
/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
if ((SEC_inGroup('Root')) || (SEC_hasRights('stats.view'))) {
    $T->set_file('page', 'daily.thtml');
} else {
    $T->set_file('page', 'daily-a.thtml');
}
$T->set_block('page','ROW','ABlock');
$T->set_var('header', $LANG_ST00['visitor_stats']);
$T->set_var('title', "$month $year - " . $LANG_ST00['daily_title']);
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('period_title',$LANG_ST00['day_title']);
$T->set_var('anon_title',$LANG_ST00['anon_title']);
$T->set_var('reg_title',$LANG_ST00['reg_title']);
$T->set_var('page_title',$LANG_ST00['page_title']);
$T->set_var('story_title',$LANG_ST00['story_title']);
$T->set_var('comm_title',$LANG_ST00['comm_title']);
$T->set_var('link_title',$LANG_ST00['link_title']);
$anon=0;
$reg=0;
$pages=0;
$stories=0;
$comments=0;
$linksf=0;
$days = DaysInMonth($month,$year);
for($day=1;$day<=$days;$day++) {
    $T->set_var('day',$day);
    $T->set_var('mon',$month);
    $T->set_var('year',$year);
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where uid='1' AND day=$day AND month='$month' AND year='$year' GROUP by ip");
    $anon += DB_numRows($rec);
    $T->set_var('anon', DB_numRows($rec));
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where uid>'1' AND day=$day AND month='$month' AND year='$year' GROUP BY ip");
    $reg += DB_numRows($rec);
    $T->set_var('reg', DB_numRows($rec));
    $rec=DB_query("SELECT page from {$_TABLES['userstats']} WHERE month='$month' AND day=$day AND year='$year'");
    $pages += DB_numRows($rec);
    $T->set_var('pages',DB_numRows($rec));
    $rec=DB_query("SELECT date from {$_TABLES['stories']} WHERE DATE_FORMAT(date,'%b')='$month' AND DAYOFMONTH(date)=$day AND YEAR(date)='$year'");
    $stories += DB_numRows($rec);
    $T->set_var('stories',DB_numRows($rec));
    $rec=DB_query("SELECT date from {$_TABLES['comments']} WHERE DATE_FORMAT(date,'%b')='$month' AND DAYOFMONTH(date)=$day AND YEAR(date)='$year'");
    $comments += DB_numRows($rec);
    $T->set_var('comments',DB_numRows($rec));
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where page='portal.php' AND day=$day AND month='$month' AND year='$year'");
    $linksf += DB_numRows($rec);
    $T->set_var('linksf',DB_numRows($rec));
    $T->Parse('ABlock','ROW',true);
}
$T->set_var('period',$LANG_ST00['total']);
$T->set_var('anon', $anon);
$T->set_var('reg', $reg);
$T->set_var('pages',$pages);
$T->set_var('stories',$stories);
$T->set_var('comments',$comments);
$T->set_var('linksf',$linksf);

$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();

echo $display;
?>