<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | day.php                                                                   |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let Root users access this page
if ((!SEC_inGroup('Root')) && (!SEC_hasRights('stats.view'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/* 
* Main Function
*/

$display = COM_siteHeader('none');
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
$T->set_file('page', 'table.thtml');
$T->set_block('page','COLUMN','CBlock');
$T->set_block('page','ROW','BBlock');
$T->set_block('page','TABLE','ABlock');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('header', $LANG_ST00['visitor_stats']);
if ($day != '') {
    $T->set_var('title', "$month $day, $year " . $LANG_ST00['views']);
} else {
    $T->set_var('title', "$month $year " . $LANG_ST00['views']);
}
$T->set_var('numcols',7);
$T->set_var('width','100%');
$T->set_var('ref_url',$_CONF['site_url'] . '/stats/index.php');
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=views" . '">' . $LANG_ST00['page_views'] . "</a>");
$T->parse('CBlock','COLUMN',false);
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=uid" . '">' . $LANG_ST00['uid'] . "</a>");
$T->parse('CBlock','COLUMN',true);
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=username" . '">' . $LANG_ST00['user'] . "</a>");
$T->parse('CBlock','COLUMN',true);
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=ip" . '">' . $LANG_ST00['ip'] . "</a>");
$T->parse('CBlock','COLUMN',true);
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=host" . '">' . $LANG_ST00['hostname'] . "</a>");
$T->parse('CBlock','COLUMN',true);
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=time" . '">' . $LANG_ST00['time'] . "</a>");
$T->parse('CBlock','COLUMN',true);
$T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/day.php?{$QUERY_STRING}&sort=referer" . '">' . $LANG_ST00['referer'] . "</a>");
$T->parse('CBlock','COLUMN',true);
$T->set_var('rowformat','style="background-color: #DDDDDD;"');
$T->parse('BBlock','ROW',true);
$T->set_var('rowformat','');

if ($day != '') {
    $sql = "Select count(*) as views, uid, username, ip, host, referer, hour, minute from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' AND day=$day ";
    if ($anon == '1') {
        $sql .= "AND uid='1'";
    } else if ($anon == '2') {
        $sql .= "AND uid>'1'";
    }    
    $sql .= " group by uid, ip, date ";
    switch ($sort) {
        case '':
        case 'views':
            $sql .= " order by views desc, username asc";
            break;
        case 'uid':
            $sql .= " order by uid";
            break;
        case 'username':
            $sql .= " order by username asc";
            break;
        case 'host':
            $sql .= " order by host asc";
            break;
        case 'time':
            $sql .= " order by hour desc, minute desc, username asc";
            break;
        case 'referer':
            $sql .= " order by referer, username asc";
            break;
    }
} else {
    $sql = "Select count(*) as views, uid, username, ip, host, referer, hour, minute from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' ";
    if ($anon == '1') {
        $sql .= "AND uid='1'";
    } else if ($anon == '2') {
        $sql .= "AND uid>'1'";
    }    
    $sql .= " group by uid, ip, date order by views desc, username asc";
}
$rec = DB_query($sql);
$nrows = DB_numRows($rec);
for ($i=0; $i<$nrows; $i++) {
    $A=DB_fetchArray($rec);
    $T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/page.php?year=$year&month=$month&day=$day&ip=" . $A['ip'] . '&uid=' . $A['uid'] . '">' . $A['views'] . "</a>");
    $T->parse('CBlock','COLUMN',false);
    $T->set_var('data','<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&uid=' . $A['uid'] . '">' . $A['uid'] . "</a>");
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',$A['username']);
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',$A['ip']);
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data','<a href="http://' . $A['host'] . '">' . $A['host'] . '</a>');
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',$A['hour'] . ':' . $A['minute']);
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data','<a href="' . $A['referer'] . '">' . $A['referer'] . "</a>");
    $T->parse('CBlock','COLUMN',true);
    $T->parse('BBlock','ROW',true);
}
$T->Parse('ABlock','TABLE',true);

$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();

echo $display;
?>