<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

//
// Only let Root users access this page Unless $_ST_anon set to 1
//
if ((!SEC_inGroup('Root')) && ($_ST_anon != 1) && (SEC_hasRights('stats.admin'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/* 
* Main Function
*/

$display = COM_siteHeader('none');
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
if ((SEC_inGroup('Root')) || (SEC_hasRights('stats.view'))) {
    $T->set_file('page', 'index.thtml');
} else {
    $T->set_file('page', 'index-a.thtml');
}
$T->set_block('page','MONTH','ABlock');
$T->set_var('header', $LANG_ST00['visitor_stats']);
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('month_title',$LANG_ST00['month_title']);
$T->set_var('title',$LANG_ST00['monthly_title']);
$T->set_var('anon_title',$LANG_ST00['anon_title']);
$T->set_var('reg_title',$LANG_ST00['reg_title']);
$T->set_var('page_title',$LANG_ST00['page_title']);
$T->set_var('story_title',$LANG_ST00['story_title']);
$T->set_var('comm_title',$LANG_ST00['comm_title']);
$T->set_var('link_title',$LANG_ST00['link_title']);
$T->set_var('hour_title',$LANG_ST00['hour_title']);
$T->set_var('referer_title',$LANG_ST00['referer_title']);
$T->set_var('country_title',$LANG_ST00['country_title']);
$T->set_var('browser_title',$LANG_ST00['browser_title']);
$T->set_var('platform_title',$LANG_ST00['platform_title']);
$rec=DB_query("SELECT DISTINCT month, year from {$_TABLES['userstats']} ORDER BY year, monthn");
$rnum = DB_numRows($rec);
$_ST_MONTHS = array();
for ($i=0;$i<$rnum;$i++) {
    $A = DB_fetchArray($rec);
    array_push($_ST_MONTHS,$A['month'] . " " . $A['year']);
}
$anon=0;
$reg=0;
$pages=0;
$stories=0;
$comments=0;
$linksf=0;
$referers=0;
$countries=0;
foreach ($_ST_MONTHS as $month) {
    $T->set_var('month',$month);
    list($month,$year) = explode(" ",$month);
    $T->set_var('mon',$month);
    $T->set_var('year',$year);
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where uid='1' AND month='$month' AND year='$year' group by ip, day");
    $anon += DB_numRows($rec);
    $T->set_var('anon', DB_numRows($rec));
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where uid>'1' AND month='$month' AND year='$year' group by ip, day");
    $reg += DB_numRows($rec);
    $T->set_var('reg', DB_numRows($rec));
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} WHERE month='$month' AND year='$year'");
    $pages += DB_numRows($rec);
    $T->set_var('pages',DB_numRows($rec));
    $rec=DB_query("SELECT date from {$_TABLES['stories']} WHERE DATE_FORMAT(date,'%b')='$month' AND YEAR(date)='$year'");
    $stories += DB_numRows($rec);
    $T->set_var('stories',DB_numRows($rec));
    $rec=DB_query("SELECT date from {$_TABLES['comments']} WHERE DATE_FORMAT(date,'%b')='$month' AND YEAR(date)='$year'");
    $comments += DB_numRows($rec);
    $T->set_var('comments',DB_numRows($rec));
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where page='portal.php' AND month='$month' AND year='$year'");
    $linksf += DB_numRows($rec);
    $T->set_var('linksf',DB_numRows($rec));
    $rec=DB_query("SELECT ip from {$_TABLES['userstats']} where month='$month' AND year='$year' group by hour, day");
    $T->set_var('byhour','X');
    $rec1 = DB_query("select count(referer) from {$_TABLES['userstats']} where mid(referer,1,LENGTH('{$_CONF['site_url']}'))!='{$_CONF['site_url']}' AND referer!='' AND  month='$month' AND year='$year'");
    $B=DB_fetchArray($rec1);
    $referers += $B[0];
    $T->set_var('referer',$B[0]);
    $rec1 = DB_query("SELECT right(host,instr(reverse(host),'.')-1) as country from {$_TABLES['userstats']} WHERE ascii(reverse(host))>64 AND month='$month' AND year='$year' GROUP BY country");
    $countries += DB_numRows($rec1);
    $T->set_var('country',DB_numRows($rec1));
    $T->set_var('browser','X');
    $T->set_var('platform','X');
    $T->Parse('ABlock','MONTH',true);
}
$T->set_var('month',$LANG_ST00['total']);
$T->set_var('anon', $anon);
$T->set_var('reg', $reg);
$T->set_var('pages',$pages);
$T->set_var('stories',$stories);
$T->set_var('comments',$comments);
$T->set_var('linksf',$linksf);
$T->set_var('byhour','NA');
$T->set_var('referer',$referers);
$T->set_var('country',$countries);
$T->set_var('browser','NA');
$T->set_var('platform','NA');
$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();

echo $display;
?>