<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | links.php                                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// | Modifications by Danny at Squatty.com for integration with phplinks       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let Root users access this page unless anon access has been okayed
if ((!SEC_inGroup('Root')) && ($_ST_anon != 1) && (!SEC_hasRights('stats.view'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
$T->set_file('page', 'table.thtml');
$T->set_block('page','COLUMN','CBlock');
$T->set_block('page','ROW','BBlock');
$T->set_block('page','TABLE','ABlock');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('header', $LANG_ST00['visitor_stats']);
if ($day != '') {
    $T->set_var('title', "$month $day, $year " . $LANG_ST00['links_followed']);
} else {
    $T->set_var('title', "$month $year " . $LANG_ST00['links_followed']);
}
$T->set_var('numcols',4);
$T->set_var('width','100%');
$T->set_var('ref_url',$_CONF['site_url'] . '/stats/index.php');
$T->set_var('data',$LANG_ST00['count']);
$T->parse('CBlock','COLUMN',false);
$T->set_var('data',$LANG_ST00['link']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['uid']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['user']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('rowformat','style="background-color: #DDDDDD;"');
$T->parse('BBlock','ROW',true);
$T->set_var('rowformat','');

if ($day != '') {
    $sql = "SELECT count(query_string) as cnt, query_string, uid from {$_TABLES['userstats']} where page='portal.php' AND day=$day AND month='$month' AND year='$year' GROUP BY query_string ORDER by cnt DESC";
} else {
    $sql = "SELECT count(query_string) as cnt, query_string, uid from {$_TABLES['userstats']} where page='portal.php' AND month='$month'  AND year='$year' GROUP BY query_string ORDER BY cnt DESC";
}
$rec = DB_query($sql);
$nrows = DB_numRows($rec);
for ($i=0; $i<$nrows; $i++) {
    $A=DB_fetchArray($rec);
    $query1 = explode('&',$A['query_string']);
    if ($_ST_phplinks == 1) {
        $query = explode('=',$query1[1]);
        $id = urldecode($query[1]);      
        if (!empty($id)){
           $sql = "select SiteName from {$_TABLES['pllinks']} where id=$id";
           $row = DB_fetchArray(DB_query($sql));
           $title = $row[SiteName];
        }
        $T->set_var('data',$A['cnt']);
        $T->parse('CBlock','COLUMN',false);
        $T->set_var('data','<a href="' . $_CONF['site_url'] . '/phplinks/out_frame.php?&ID=' . $id . '">' . $title . "</a>");
    } else {
        $query = explode('=',$query1[0]);
        $title = urldecode($query[1]);
        $T->set_var('data',$A['cnt']);
        $T->parse('CBlock','COLUMN',false);
        $T->set_var('data','<a href="http://' . $title . '">' . $title . "</a>");
    }
    $T->parse('CBlock','COLUMN',true);
    if ($A['uid'] > 1){
        $T->set_var('data','<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&uid=' . $A['uid'] . '">' . $A['uid'] . "</a>");
    } else {
        $T->set_var('data',$A['uid']);
    }
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',DB_getItem($_TABLES['users'],'username',"uid='" . $A['uid'] . "'"));
    $T->parse('CBlock','COLUMN',true);
    $T->parse('BBlock','ROW',true);
}
                                                                                        
$T->Parse('ABlock','TABLE',true);

$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();

echo $display;
?>