<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | page.php                                                                  |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let Root users access this page
if ((!SEC_inGroup('Root')) && (!SEC_hasRights('stats.view'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/* 
* Main Function
*/

$display = COM_siteHeader('none');
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
$T->set_file('page', 'table.thtml');
$T->set_block('page','COLUMN','CBlock');
$T->set_block('page','ROW','BBlock');
$T->set_block('page','TABLE','ABlock');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('header', $LANG_ST00['visitor_stats']);
if ($ip != '') {
    $tmp = "by $ip";
}
if ($page != '') {
    $tmp = "of $page";
}
if ($day != '') {
    if ($page == '') {
        $T->set_var('title', '<a href="' . $CONF['site_url'] . "/stats/page.php?year=$year&month=$month&ip=$ip" . '">' . "<em>$month</em></a> $day, <a href=\"{$_CONF['site_url']}/stats/page.php?year=$year&ip=$ip\"><em>$year</em></a> {$LANG_ST00['page_views']} $tmp");
    } else {
        $T->set_var('title', '<a href="' . $CONF['site_url'] . "/stats/page.php?year=$year&month=$month&page=$page" . '">' . "<em>$month</em></a> $day, <a href=\"{$_CONF['site_url']}/stats/page.php?year=$year&page=$page\"><em>$year</em></a> {$LANG_ST00['page_views']} $tmp");
    }
} else {
    if ($page == '') {
        $T->set_var('title', "$month</a> <a href=\"{$_CONF['site_url']}/stats/page.php?year=$year&ip=$ip\"><em>$year</em></a> {$LANG_ST00['page_views']} $tmp");
    } else {
        $T->set_var('title', "$month</a> <a href=\"{$_CONF['site_url']}/stats/page.php?year=$year&page=$page\"><em>$year</em></a> {$LANG_ST00['page_views']} $tmp");
    }
}
$T->set_var('numcols',8);
$T->set_var('width','100%');
$T->set_var('ref_url', $_CONF['site_url'] . '/stats/index.php');
$T->set_var('data',$LANG_ST00['type']);
$T->parse('CBlock','COLUMN',false);
$T->set_var('data',$LANG_ST00['ptu']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['uid']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['user']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['ip']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['hostname']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['datetime']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('data',$LANG_ST00['referer']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('rowformat','style="background-color: #DDDDDD;"');
$T->parse('BBlock','ROW',true);
$T->set_var('rowformat','');

if ($day != '') {
    $sql = "Select page, uid, username, ip, host, referer, query_string, year, month, day, hour, minute, request from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' AND day=$day ";
    if ($anon == '1') {
        $sql .= "AND uid='1'";
    } else if ($anon == '2') {
        $sql .= "AND uid>'1'";
    }    
    if ($ip != '') {
        $sql .= " AND ip='$ip' ";
    }
    if ($uid > 1) {
        $sql .= " AND uid='$uid' ";
    }
    if ($day != '') {
        $sql .= " AND day=$day ";
    }
    if ($page != '') {
        $sql .= " AND page='$page'";
    }
} else {
    $sql = "Select page, uid, username, ip, host, referer, query_string, year, month, day, hour, minute, request from {$_TABLES['userstats']} WHERE year='$year' ";
    if ($anon == '1') {
        $sql .= "AND uid='1'";
    } else if ($anon == '2') {
        $sql .= "AND uid>'1'";
    }    
    if ($month != '') {
        $sql .= " AND month='$month' ";
    }
    if ($ip != '') {
        $sql .= " AND ip='$ip' ";
    }
    if ($uid > 1) {
        $sql .= " AND uid='$uid' ";
    }
    if ($page != '') {
        $sql .= " AND page='$page'";
    }
}
$sql .= " ORDER by date, hour, minute";
$rec = DB_query($sql);
$nrows = DB_numRows($rec);
for ($i=0; $i<$nrows; $i++) {
    $A=DB_fetchArray($rec);
    $T->set_var('data',$A['request']);
    $T->parse('CBlock','COLUMN',false);
    if ($A['page'] == 'article.php') {
        $query1 = explode('&',$A['query_string']);
        $query = explode('=',$query1[0]);
        $title = DB_getItem($_TABLES['stories'],'title', "sid = '$query[1]'");
        if ($title == '') { $title=$A['page']; }
        $T->set_var('data','<a href="' . $_CONF['site_url'] . '/' . $A['page'] . '?' . $A['query_string'] . '">' . $title . "</a>");
    } else if ($A['page'] == 'staticpages/index.php') {
        $query1 = explode('&',$A['query_string']);
        $query = explode('=',$query1[0]);
        $title = DB_getItem($_TABLES['staticpage'],'sp_title', "sp_id = '$query[1]'");
        if ($title == '') { $title=$A['page']; }
        $T->set_var('data','<a href="' . $_CONF['site_url'] . '/' . $A['page'] . '?' . $A['query_string'] . '">' . $title . "</a>");
    } else if (($A['page'] == 'portal.php') || ($A['page'] == 'download.php')) {
        $query1 = explode('&',$A['query_string']);
        $query = explode('=',$query1[0]);
        $title = urldecode($query[1]);
        if (($title == '') || ($title == 'yes')) { $title=$A['page']; }
        $T->set_var('data','<a href="' . $_CONF['site_url'] . '/' . $A['page'] . '?' . $A['query_string'] . '">' . $title . "</a>");
    } else {
        $T->set_var('data','<a href="' . $_CONF['site_url'] . '/' . $A['page'] . '?' . $A['query_string'] . '">' . $A['page'] . "</a>");
    }
    $T->parse('CBlock','COLUMN',type);
    $T->set_var('data','<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&uid=' . $A['uid'] . '">' . $A['uid'] . "</a>");
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',$A['username']);
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',$A['ip']);
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data','<a href="http://' . $A['host'] . '">' . $A['host'] . '</a>');
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data',$A['month'] . ' ' . $A['day'] . ', ' . $A['year'] . ' ' . $A['hour'] . ':' . $A['minute']);
    $T->parse('CBlock','COLUMN',true);
    $T->set_var('data','<a href="' . $A['referer'] . '">' .  urldecode($A['referer']) . "</a>");
    $T->parse('CBlock','COLUMN',true);
    $T->parse('BBlock','ROW',true);
}
$T->Parse('ABlock','TABLE',true);

$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();

echo $display;
?>