<?php

// +---------------------------------------------------------------------------+
// | Stats Plugin 1.1 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | pages.php                                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let Root users access this page
if ((!SEC_inGroup('Root')) && (!SEC_hasRights('stats.view'))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Stats page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_ST00['access_denied']);
    $display .= $LANG_ST00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/stats/templates');
$T->set_file('page', 'table.thtml');
$T->set_block('page','COLUMN','CBlock');
$T->set_block('page','ROW','BBlock');
$T->set_block('page','TABLE','ABlock');
$T->set_var('header', $LANG_ST00['visitor_stats']);
$T->set_var('site_url',$_CONF['site_url']);
if ($day != '') {
    $T->set_var('title', "$month $day, $year " . $LANG_ST00['views_per_page']);
} else {
    $T->set_var('title', "$month $year " . $LANG_ST00['views_per_page']);
}
$T->set_var('numcols',2);
$T->set_var('width','50%');
$T->set_var('ref_url',$_CONF['site_url'] . '/stats/index.php');
$T->set_var('data',$LANG_ST00['page']);
$T->parse('CBlock','COLUMN',false);
$T->set_var('data',$LANG_ST00['page_views']);
$T->parse('CBlock','COLUMN',true);
$T->set_var('rowformat','style="background-color: #DDDDDD;"');
$T->parse('BBlock','ROW',true);
$T->set_var('rowformat','');
if ($day != '') {
    $rec = DB_query("Select count(*) as count, page from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' AND day=$day group by page order by count desc");
} else {
    $rec = DB_query("Select count(*) as count, page from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' group by page order by count desc");
}
$nrows = DB_numRows($rec);
$pageviews=0;
for ($i=0; $i<$nrows; $i++) {
    $A=DB_fetchArray($rec);
    $T->set_var('data','<a href="' . $_CONF['site_url'] . "/stats/page.php?year=$year&month=$month&day=$day&page=" . $A['page'] . '">' . $A['page'] . "</a>");
    $T->parse('CBlock','COLUMN',false);
    $T->set_var('data',$A['count']);
    $pageviews += $A['count'];
    $T->parse('CBlock','COLUMN',true);
    $T->parse('BBlock','ROW',true);
}
$T->set_var('data',$LANG_ST00['total']);
$T->parse('CBlock','COLUMN',false);
$T->set_var('data',$pageviews);
$T->parse('CBlock','COLUMN',true);
$T->set_var('rowformat','style="background-color: #DDDDDD;"');
$T->parse('BBlock','ROW',true);
$T->Parse('ABlock','TABLE',true);

if ($day != '') {
    $rec = DB_query("Select DISTINCT ip from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' AND day=$day");
} else {
    $rec = DB_query("Select ip from {$_TABLES['userstats']} WHERE year='$year' AND month='$month' GROUP BY ip, day");
}
$visitors = DB_numRows($rec);

$T->set_var('summary',"$pageviews {$LANG_ST00['total']} {$LANG_ST00['views_per_page']}<br>$visitors {$LANG_ST00['unique_visitors']}<br>" . sprintf("%01.2f",$pageviews/$visitors) . " {$LANG_ST00['views']}.<br>");

$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();

echo $display;
?>